// -*- MaTX -*-

// sim00021.mm: tmd00021.{h,mm} ΥƥȤΤΥߥ졼
//
//   Originally written by KIYOTA Hiromitsu <1999/05/31>
//   Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
//
// RCS: $Id: sim00021.mm,v 1.2 1999/07/12 14:04:07 kiyota Exp $

// Local options
//#define NOPLOT
//#define MULTIPLOT

// These are required #definitions.
#define TMD00021_USER_H "sim00021.h"
#define TMD00021_USER_MM "sim00021.mm"

// TMD00021_USER_H  #include 롣
#include "tmd00021.h"


// ϤˤΥѥ᡼
Real d, A;

Func void
main()
{
  Matrix TC, XC, UC;
  Matrix link_eqs();
  Integer j;
#ifndef NOPLOT
  List names;
  Integer i;
  Integer replot;
#ifdef MULTIPLOT
  Integer hmultiplot(...) require "hplot.mm";
#endif /* MULTIPLOT */
#endif /* ! NOPLOT */
  List As;

//  init_tmd00021(1); // Υߥ졼(not given)
  init_tmd00021(0); // Υߥ졼

  d = 0.1; /* msec */ // Ȥ
  As = {0.0, 40.0, 80.0, 120.0, 160.0, 200.0}; /* uA/cm^2 */ // Ȥι⤵

#ifndef NOPLOT
  replot = 0;
#endif /* ! NOPLOT */
  for (j = 1; j <= length(As); ++j)
    {
      A = As(j, Real);
//      print A;

      {TC, XC, UC} = Ode45(0.0, 8.0, /* msec */
#ifndef TMD00021_USER_DIFF
			   // initial values not given
			   [0.0, 0.0, 0.0, 0.0]', // V, m, h, n
#else /* TMD00021_USER_DIFF */
			   [[0.0, 0.0, 0.0, 0.0], // V, m, h, n
			    [0.0, 0.0]]', // ưŪν
#endif /* ! TMD00021_USER_DIFF */
			   diff_tmd00021, link_eqs, 0.01);
      print [[TC][XC][UC]] >> "sim.mat";

#ifndef NOPLOT
      names = {"x1(=V),A="+String(A), "x2(=m)", "x3(=h)", "x4(=n)", // XC
#ifdef TMD00021_USER_DIFF
	       "(x5)", "(x6)",  // ưŪξ
#endif /* TMD00021_USER_DIFF */
	       "u(=I)", "-" // UC
	       };

#ifndef MULTIPLOT
      for (i = 1; i <= length(names); ++i)
	{
	  if (names(i, String) == "-") { continue; }
	  mgplot_grid(i, 1);
	  if (! replot)
	    {
	      mgplot(i, TC(1,:), [[XC][UC]](i,:), {names(i, String)});
	    }
	  else
	    {
	      mgreplot(i, TC(1,:), [[XC][UC]](i,:), {names(i, String)});
	      replot = 1;
	    }	      
	}
#else /* MULTIPLOT */
      hmultiplot(1, TC, [[XC][UC]], names, replot);
      replot = 1;
#endif /* ! MULTIPLOT */
//      pause;
#endif /* ! NOPLOT */
    }
  pause;
}


Func Matrix
link_eqs(t, xx)
     Real t;
     Matrix xx;
{
  Matrix uy;
  static Integer running;
  static Matrix u;
  Matrix x, y;
  Real I;

  if (running == 0) // ߥ졼󳫻ϻ
    {
      uy = Z(TMD00021_DIM_ALL_IOS,1);
      u = chop_input_tmd00021(uy);
      running = 1;
    }

  x = chop_state_tmd00021(xx);
  y = output_tmd00021(t, x, u);

  if ((t >= 0) && (t < d))
    {
      I = A; /* uA/cm^2 */
    }
  else
    {
      I = 0.0;
    }
  u(1) = I;

  uy = [[u]
	[y]];
  return uy;
}


#ifdef TMD00021_USER_DIFF
// ߡưŪ
Func Matrix
TMD00021_USER_DIFF(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix x, z, u, y; // z ϤǤϴ¬ξ֤ʤ

  x = chop_state_tmd00021(xx);
  z = chop_other_state_tmd00021(xx);
  u = chop_input_tmd00021(uu);
  y = output_tmd00021(t, x, u);
  // etc.

  return [1.0, -1.0]'; // ߡΤøʥʥߥ ;-)
}
#endif /* TMD00021_USER_DIFF */
