/* -*- MaTX -*-
 *
 * tmd00021.mm: TMD No. tmd00021 ۥ-ϥ쥤ǥ
 *
 *  Originally written by KIYOTA Hiromitsu <1999/05/30>
 *  Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
 *
 * RCS: $Id: tmd00021.mm,v 1.2 1999/06/29 03:58:53 kiyota Exp $
 */

#ifndef _TMD00021_MM
#define _TMD00021_MM

#ifndef TMD_EXTERN
#define TMD_EXTERN extern
#endif /* ! TMD_EXTERN */
#include "tmd00021.h"

// some definitions for local alist
#define _TMD_LALIST {"_tmd00021"}
#define _TMD_LIN_FLAG "linear_flag"

// just for simplicity... B)
#define tmd21(var) tmd00021(var)

Func void
init_tmd00021(linear_flag, params_flag, ...)
     Integer linear_flag, params_flag;
{
#ifndef TMD00021_DISABLE_HALIST
  List halist(...);
#endif /* ! TMD00021_DISABLE_HALIST */

  switch (nargs)
    {
    case 2:
      break;
    case 0:
      linear_flag = 0; // ǥե: ǥ
    case 1:
      params_flag = 0; // ǥե: ѥ᡼̤
      break;
    default:
      error("init_tmd00021(): Incorrect number of arguments. (nargs=%d)\n", nargs);
      break;
    }

  // ()Υե饰
#ifndef TMD00021_DISABLE_HALIST
  if (halist({_TMD_LALIST, "exists"}) == {})  // if not exist
    {
      halist({_TMD_LALIST, "clear"});  // new alist
    }
  halist(_TMD_LALIST, {{_TMD_LIN_FLAG, linear_flag}});
#else /* TMD00021_DISABLE_HALIST */
  tmd00021_flag = linear_flag;
#endif /* ! TMD00021_DISABLE_HALIST */

  if (params_flag == 0)
    {
      tmd21(CM) = 1.0; /* uF/cm^2 */	// 
      tmd21(gNa_hat) = 120.0; /* mS/cm^2 */	// ʥȥꥦॳ
      tmd21(gK_hat) = 40.0; /* mS/cm^2 */	// 祫ꥦॳ
      tmd21(gl_hat) = 0.24; /* mS/cm^2 */	// ꡼
      tmd21(VNa) = 115.0; /* mV */	// ŻṲ̋ȤΥʥȥꥦʿŰ
      tmd21(VK) = -12.0; /* mV */	// ŻṲ̋ȤΥꥦʿŰ
      tmd21(Vl) = 10.613; /* mV */	// ŻṲ̋ȤΥ꡼ʿŰ
    }

}


Func Matrix
diff_tmd00021(t, xx, uu)
     Real t; /* msec */	// 
     Matrix xx, uu;
{
  Matrix dxx;
#ifndef TMD00021_DISABLE_HALIST
  List halist(...);
#endif /* ! TMD00021_DISABLE_HALIST */
  Matrix dx, x, u;
#ifdef TMD00021_USER_DIFF
  Matrix TMD00021_USER_DIFF();
#endif /* TMD00021_USER_DIFF */
  Real V, m, h, n, I, dV, dm, dh, dn;
  Real alpha_m, beta_m, alpha_h, beta_h, alpha_n, beta_n;

  x = chop_state_tmd00021(xx);
  u = chop_input_tmd00021(uu);

#if 0
#ifndef TMD00021_DISABLE_HALIST
  if (halist(_TMD_LALIST, {_TMD_LIN_FLAG}) == {0}) // ǥ
#else /* TMD00021_DISABLE_HALIST */
  if (tmd00021_flag == 0) // ǥ
#endif /* ! TMD00021_DISABLE_HALIST */
    {
#endif /* 0 */
      I = u(1); /* uA/cm^2 */	// ή̩
      V = x(1); /* mV */	// Ű
      m = x(2); /* dimensionless */	// ʥȥꥦѿ
      h = x(3); /* dimensionless */	// ʥȥꥦԳѿ
      n = x(4); /* dimensionless */	// ꥦѿ
      // alpha_m, beta_m: ѿ m ®()
      alpha_m = 0.1*(V + 25.0)/(exp((V + 25.0)/10.0) - 1.0); /* msec^(-1) */
      beta_m = 4.0*exp(V/80.0); /* msec^(-1) */
      // alpha_h, beta_h: ѿ h ®()
      alpha_h = 0.07*exp(V/20.0); /* msec^(-1) */
      beta_h = 1.0/(exp((V + 30.0)/10.0) + 1); /* msec^(-1) */
      // alpha_n, beta_n: ѿ n ®()
      alpha_n = 0.01*(V + 10.0)/(exp((V + 10.0)/10.0) - 1.0); /* msec^(-1) */
      beta_n = 0.125*exp(V/80.0); /* msec^(-1) */

      dV = (I - tmd21(gK_hat)*n^4*(V - tmd21(VK)) - tmd21(gNa_hat)*m^3*h*(V - tmd21(VNa)) - tmd21(gl_hat)*(V - tmd21(Vl)))/tmd21(CM);
      dm = alpha_m*(1.0 - m) - beta_m*m;
      dh = alpha_h*(1.0 - h) - beta_h*h;
      dn = alpha_n*(1.0 - n) - beta_n*n;
      dx = [dV, dm, dh, dn]';
#if 0
    }
  else // ǥ
    {
      // not given.
    }
#endif /* 0 */

  dxx = [[dx]
#ifdef TMD00021_USER_DIFF
	 [TMD00021_USER_DIFF(t, xx, uu)]
#endif /* TMD00021_USER_DIFF */
	 ];
  return dxx;
}


Func Matrix
output_tmd00021(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix x, u, y;
  Real V;

  x = chop_state_tmd00021(xx);
  u = chop_input_tmd00021(uu);

  V = x(1);
  y = [V]';

  return y;
}

#undef tmd21
#undef _TMD_LALIST
#undef _TMD_LIN_FLAG

#endif /* !_TMD00021_MM */
